//
//  CALayer+Category.m
//  RippleImageView
//
//  Created by LY on 2016/12/9.
//  Copyright © 2016年 LY. All rights reserved.
//

#import "CALayer+Category.h"

@implementation CALayer (Category)

- (void)pauseAnimation
{
    CFTimeInterval time = [self convertTime:CACurrentMediaTime() fromLayer:nil];
    self.speed = 0;
    self.timeOffset = time;
}

- (void)resumeAnimation
{
    CFTimeInterval time = [self timeOffset];
    self.speed = 1;
    self.timeOffset = 0;
    self.beginTime = 0;
    CFTimeInterval pause = [self convertTime:CACurrentMediaTime() fromLayer:nil] - time;
    self.beginTime = pause;
}

- (UIImage *)screenShot
{
    UIImage *image;
    UIGraphicsBeginImageContext(self.bounds.size);
    CGContextRef ctx = UIGraphicsGetCurrentContext();
    if (ctx == NULL) {UIGraphicsEndImageContext(); return nil;}
    [self renderInContext:ctx];
    image = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    return image;
}

- (void)drawGradientColors:(NSArray *)colors locations:(NSArray *)locations path:(CGPathRef)path start:(CGPoint)start end:(CGPoint)end
{
    NSMutableArray *arrcolor = [NSMutableArray array];
    for (UIColor *color in colors)
    {
        [arrcolor addObject:(__bridge id)color.CGColor];
    }
    CGFloat arrlocation[locations.count];
    for (NSInteger i = 0; i < locations.count; i ++)
    {
        arrlocation[i] = [locations[i] floatValue];
    }
    
    CGContextRef ctx = UIGraphicsGetCurrentContext();
    if (ctx == NULL)
    {
        return;
    }
    
    CGColorSpaceRef colorSpace = CGColorSpaceCreateDeviceRGB();
    CGGradientRef gradient = CGGradientCreateWithColors(colorSpace, (__bridge CFArrayRef)arrcolor, arrlocation);
    
    CGContextSaveGState(ctx);
    CGContextAddPath(ctx, path);
    CGContextClip(ctx);
    CGContextDrawLinearGradient(ctx, gradient, start, end, 0); //开始绘制
    CGContextRestoreGState(ctx);
    
    //释放资源
    CGGradientRelease(gradient);
    CGColorSpaceRelease(colorSpace);
}

@end
