//
//  ViewController.m
//  RippleImageView
//
//  Created by LY on 2016/12/9.
//  Copyright © 2016年 LY. All rights reserved.
//

#import "ViewController.h"
#import "UIImageView+Category.h"
#import "LYSlider.h"
#import "CG_Extention.h"
#import "UIView+Category.h"
#import "UIImage+Category.h"
#import "NSObject+Category.h"

#define kScreenHight    (MAX([[UIScreen mainScreen] bounds].size.height, [[UIScreen mainScreen] bounds].size.width))
#define kScreenWidth    (MIN([[UIScreen mainScreen] bounds].size.height, [[UIScreen mainScreen] bounds].size.width))

#define _kImageName @"riverstone"
#define _kRotate90  YES

#define _kway 2
@interface ViewController ()

@property (nonatomic, strong) UIImageView *rippleview;

@end

@implementation ViewController


- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    [self.navigationController setNavigationBarHidden:YES animated:YES];
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    
#if     _kway == 1
    [self testRippleImageView];
#elif   _kway == 2
    [self debugRippleAnimation];
#endif
}

// 替换图片
- (void)testRippleImageView
{
    [self.view addSubview:self.rippleview];
    [self reshow];
    __weak typeof(self) weakself = self;
    [self.view addGestureRecognizerType:UIViewGestureRecognizerType_Tap moreSettingForGesture:^(UIGestureRecognizer *gesture) {
        
    } shouldReceiveTouch:^BOOL(UIGestureRecognizer *gesture, UITouch *touch) {
        
        return YES;
    } callback:^(UIGestureRecognizer *gesture, UIViewGestureRecognizerType type) {
        
        __strong typeof(weakself) strongself = weakself;
        if (![strongself.navigationController isNavigationBarHidden])
        {
            [strongself reshow];
        }
        [strongself.navigationController setNavigationBarHidden:![strongself.navigationController isNavigationBarHidden] animated:YES];
    }];
}

- (void)reshow
{
    __block CGFloat amp = 14;
    __block CGFloat radius = 10;
    __block CGFloat replacer = 0;
    CGFloat maxrad = sqrt(pow(kScreenHight, 2) + pow(kScreenWidth, 2)) / 2 + 3;
    
    [self.rippleview resetRippleReplaceImage:[self image]];
    
    self.view.userInteractionEnabled = NO;
    __weak typeof(self) weakself = self;
    [self.rippleview startRippleAnimationAtPoint:CGPointMake(0.5, 0.5) radius:radius wavelength:3 amplitude:14 speed:10 callback:^BOOL{
        
        __strong typeof(weakself) strongself = weakself;
        if (radius <= maxrad)
        {
            radius += 10;
            [strongself.rippleview resetRippleRadius:radius];
        }
        else
        {
            if (replacer <= maxrad)
            {
                replacer += 16;
                [strongself.rippleview resetRippleReplaceRadius:replacer];
            }
            else
            {
                strongself.view.userInteractionEnabled = YES;
                return YES;
            }
        }
        
//        amp -= 0.1;
//        [ripview resetRippleAmplitude:amp];
//        [ripview resetRippleSpeed:10 * amp / 14];
        return amp < 0;
    }];
}

// 调试模式
- (void)debugRippleAnimation
{
    [self.view addSubview:self.rippleview];
    
    [self.rippleview startRippleAnimationAtPoint:CGPointMake(0.5, 0.5) radius:90 wavelength:3 amplitude:14 speed:10 callback:^BOOL{
        
        return NO;
    }];
    
    __weak typeof(self) weakself = self;
    
    __block CGFloat dx = 1, dy = 1;
    LYSlider *slopex = [[LYSlider alloc] initWithWidth:280 center:CGPointMake(self.view.bounds.size.width / 2, self.view.height - 240) horizontal:YES];
    [self.view addSubview:slopex];
    [slopex handleSliderAction:UIControlEventTouchUpInside callback:^(LYSlider *slider, UIControlEvents event) {
        dx = slider.value * 10;
        [weakself.rippleview resetRippleSlope_dx:dx dy:dy];
    }];
    
    LYSlider *slopey = [[LYSlider alloc] initWithWidth:280 center:CGPointMake(self.view.bounds.size.width / 2, self.view.height - 190) horizontal:YES];
    [self.view addSubview:slopey];
    [slopey handleSliderAction:UIControlEventTouchUpInside callback:^(LYSlider *slider, UIControlEvents event) {
        dy = slider.value * 10;
        [weakself.rippleview resetRippleSlope_dx:dx dy:dy];
    }];
    slopex.thumbcolor = [UIColor purpleColor];
    
    LYSlider *speed = [[LYSlider alloc] initWithWidth:280 center:CGPointMake(self.view.bounds.size.width / 2, self.view.height - 140) horizontal:YES];
    [self.view addSubview:speed];
    [speed handleSliderAction:UIControlEventTouchUpInside callback:^(LYSlider *slider, UIControlEvents event) {
        [weakself.rippleview resetRippleSpeed:60 * slider.value];
    }];
    LYSlider *amplitude = [[LYSlider alloc] initWithWidth:280 center:CGPointMake(self.view.bounds.size.width / 2, self.view.height - 90) horizontal:YES];
    [self.view addSubview:amplitude];
    [amplitude handleSliderAction:UIControlEventTouchUpInside callback:^(LYSlider *slider, UIControlEvents event) {
        [weakself.rippleview resetRippleAmplitude:28 * slider.value];
    }];
    LYSlider *radiu = [[LYSlider alloc] initWithWidth:280 center:CGPointMake(self.view.bounds.size.width / 2, self.view.height - 40) horizontal:YES];
    [self.view addSubview:radiu];
    [radiu handleSliderAction:UIControlEventTouchUpInside callback:^(LYSlider *slider, UIControlEvents event) {
        [weakself.rippleview resetRippleRadius:300 * slider.value];
    }];
    
    __block BOOL restart = NO;
    [self.view addGestureRecognizerType:UIViewGestureRecognizerType_Tap moreSettingForGesture:^(UIGestureRecognizer *gesture) {
        
    } shouldReceiveTouch:^BOOL(UIGestureRecognizer *gesture, UITouch *touch) {
        
        //添加手势会截取touch事件,使tableView:didSelectRowAtIndexPath:不响应
        if (([NSStringFromClass([touch.view class]) isEqualToString:@"UITableViewCellContentView"] || [touch.view isKindOfClass:[UIButton class]]) || [touch.view isKindOfClass:[LYSlider class]])
        {
            return NO;
        }
        return YES;
        
    } callback:^(UIGestureRecognizer *gesture, UIViewGestureRecognizerType type) {
        
        CGPoint center = [gesture locationInView:weakself.rippleview];
        __strong typeof(weakself) strongself = weakself;
        
        // 点击左上角停止动画
        if (center.x < 60 && center.y < 100)
        {
            [strongself.navigationController setNavigationBarHidden:NO animated:YES];
            [strongself.rippleview suspendRippleAnimation];
            restart = YES;
        }
        else // 点击其他地方 开始动画
        {
            if (restart)
            {
                [strongself.navigationController setNavigationBarHidden:YES animated:YES];
                [strongself.rippleview restartRippleAnimation];
                restart = NO;
            }
            center.x = center.x / strongself.rippleview.width;
            center.y = center.y / strongself.rippleview.height;
            [strongself.rippleview resetRippleCenter:center];
        }
    }];
}

- (UIImageView *)rippleview
{
    if (_rippleview == nil)
    {
        __block UIImage *imgo;
        imgo = [self image];
        _rippleview = [[UIImageView alloc] initWithFrame:self.view.bounds];
        _rippleview.image = imgo;
        _rippleview.userInteractionEnabled = YES;
    }
    return _rippleview;
}

- (UIImage *)image
{
    UIImage *image = [UIImage imageNamed:_kImageName];
    if (_kRotate90)
    {
        image = [image rotatingWithRotation:ImageRotatingTo_Right];
    }
    return image;
}

@end
